<!doctype html>
<html lang="en">
   <head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
		<link rel="icon" href="favicon.ico" />
		<title>Bours'Ô Places</title>
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha512-rO2SXEKBSICa/AfyhEK5ZqWFCOok1rcgPYfGOqtX35OyiraBg6Xa4NnBJwXgpIRoXeWjcAmcQniMhp22htDc6g==" crossorigin="anonymous" />
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/css/select2.min.css" integrity="sha512-nMNlpuaDPrqlEls3IX/Q56H36qvBASwb3ipuo3MxeWbsQB1881ox0cRv7UPTgBlriqoynt35KjEwgGUeUXIPnw==" crossorigin="anonymous" />
   </head>
   <body>
   		<div id="main" class="container">
         	<div class="row">
         		<div class="col-12 spacer"><!--SPACER--></div>
            	<div class="col-12 alert alert-info" v-if="!hideGit">
               		<a href="https://gitlab.com/agepoly/it/dev/boursoplace/-/blob/master/README">
               			Voir https://gitlab.com/agepoly/it/dev/boursoplaces/-/blob/master/README</a>
               		<button type="button" v-on:click="hideGit = true" class="close" aria-label="Close">
               			<span aria-hidden="true">&times;</span>
               		</button>
            	</div>
	            <div class="col-12 alert alert-danger" v-if="error">
	               <p>{{ error }}</p>
	            </div>
	        </div>
   			<div class="spacer" style="height:50px;"></div>
	        <div class="row" v-if="modeHome">
	          	<div class="col-6">
	          		<div class="row-12">
		              	<div class="card-header">
		                 	<h2 class="card-title">Group Change Request</h2>
		              	</div>
			            <div class="card-body">
			                <div class="col-12" v-if="user && status==undefined">
			                  <form class="form" method="get" @submit.prevent="requestExchange">
			                    <div class="form-group row">
			                       <label class="col-sm-5" for="target">Choose desired Group</label>
			                       <select class="col-sm-6" name="target" id="target" v-model="exchangeTarget" :disabled="!user">
									    <option value="">--Please choose an option--</option>
									    <option value="0" v-if="(user && user.group) && (user.group!=0)">0</option>
									    <option value="1" v-if="(user && user.group) && (user.group!=1)">1</option>
									    <option value="2" v-if="(user && user.group) && (user.group!=2)">2</option>
									</select>
			                    </div>
			                    <button class="btn btn-primary" type="submit" :disabled="!user">Submit Request</button>
			                  </form>
			              	</div>
			              	<div class="col-12" v-if="user==undefined && status==undefined">
			                  Login to use this feature
			              	</div>
			              	<div class="col-12" v-if="user!=undefined && status!=undefined">
			                  	<table class="table">
								  	<tr>
								    	<th scope="row">Requested Group</th>
								     	<td>{{ (status.target) ? status.target  : '#' }}</td>
								  	</tr>
								  	<tr>
								    	<th scope="row">Status</th>
								    	<td>{{ (status.status) ? statusStr(status.status)  : 'Unknown' }}</td>
								    </tr>
								</table>
			              	</div>
		              	</div>
		            </div>
		            <div class="row-12" v-if="stats">
		            	<div class="card-header">
		                 	<h2 class="card-title">Requests Statistics</h2>
		              	</div>
			            <div class="card-body">
			              	<div class="col-12" >
			                  	<table class="table" v-if="stats.total && stats.complete && stats.incomplete">
			                  		<tr>
			                  			<th></th>
			                  			<th>Global</th>
			                  			<th>A</th>
			                  			<th>B</th>
			                  			<th>C</th>
								  	<tr>
								    	<th scope="row">Total Requests</th>
								     	<td>{{ stats.total.global }}</td>
								     	<td>{{ stats.total.A.from }}/{{ stats.total.A.to }}</td>
								     	<td>{{ stats.total.B.from }}/{{ stats.total.B.to }}</td>
								     	<td>{{ stats.total.C.from }}/{{ stats.total.C.to }}</td>
								  	</tr>
								  	<tr>
								    	<th scope="row">Complete Requests</th>
								     	<td>{{ stats.complete.global }}</td>
								     	<td>{{ stats.complete.A.from }}/{{ stats.complete.A.to }}</td>
								     	<td>{{ stats.complete.B.from }}/{{ stats.complete.B.to }}</td>
								     	<td>{{ stats.complete.C.from }}/{{ stats.complete.C.to }}</td>
								  	</tr>
								  	<tr>
								    	<th scope="row">Incomplete Requests</th>
								     	<td>{{ stats.incomplete.global }}</td>
								     	<td>{{ stats.incomplete.A.from }}/{{ stats.incomplete.A.to }}</td>
								     	<td>{{ stats.incomplete.B.from }}/{{ stats.incomplete.B.to }}</td>
								     	<td>{{ stats.incomplete.C.from }}/{{ stats.incomplete.C.to }}</td>
								  	</tr>
								</table>

			              		<p>Note: the following syntax is used for group requests (from/to)</p>
			              	</div>
		              	</div>
		            </div>
	            </div>
	            <div class="col-6">
	              	<div class="card-header">
	                 	<h2 class="card-title">User</h2>
	              	</div>
		            <div class="card-body">
		                <div class="col-12" v-if="!user">
							<form method="get" action="/authenticate">
		                    	<button class="btn btn-primary" type="submit">Login</button>
							</form>
		              	</div>
		              	<div class="col-12" v-if="user">
		              		<table class="table">
							  	<tr>
							    	<th scope="row">Name</th>
							     	<td>{{ (user.name) ? user.name  : '' }}</td>
							  	</tr>
							  	<tr>
							    	<th scope="row">Email</th>
							    	<td>{{ (user.email) ? user.email  : '' }}</td>
							    </tr>
							    <tr>
							    	<th scope="row">Sciper</th>
							    	<td>{{ (user.sciper) ? user.sciper  : '' }}</td>
							    </tr>
							    <tr>
							    	<th scope="row">Original Group</th>
							    	<td>{{ (user.sciper) ? parseInt(user.sciper)%3  : '?'  }}</td>
							    </tr>
							    <tr>
							    	<th scope="row">Current Group</th>
							    	<td>{{ (user.group) ? user.group  : ''  }}</td>
							    </tr>
							</table>
		              	</div>
	              	</div>
	            </div>
	        </div>
		</div>
	</body>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js" integrity="sha512-bLT0Qm9VnAYZDflyKcBaQ2gg0hSYNQrJ8RilYldYQ1FxQYoCLtUjuuRuZo+fjqhx/qtq/1itJ0C2ejDxltZVFg==" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.6.11/vue.min.js" integrity="sha512-QJsj3afWlCpnQ60XzzYE8Jb3IgHIK1BcGZox9rUSmRRq3Ocz9vQ1yR80eX2/b9jfx/UuT5zYWNdrM8Te/eCMhQ==" crossorigin="anonymous"></script>
	<!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.6.11/vue.js" integrity="sha512-PyKhbAWS+VlTWXjk/36s5hJmUJBxcGY/1hlxg6woHD/EONP2fawZRKmvHdTGOWPKTqk3CPSUPh7+2boIBklbvw==" crossorigin="anonymous"></script> -->
	<script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.19.2/axios.min.js" integrity="sha512-VZ6m0F78+yo3sbu48gElK4irv2dzPoep8oo9LEjxviigcnnnNvnTOJRSrIhuFk68FMLOpiNz+T77nNY89rnWDg==" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.full.min.js" integrity="sha512-RtZU3AyMVArmHLiW0suEZ9McadTdegwbgtiQl5Qqo9kunkVg1ofwueXD8/8wv3Af8jkME3DDe3yLfR8HSJfT2g==" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.3.0/socket.io.js" integrity="sha512-v8ng/uGxkge3d1IJuEo6dJP8JViyvms0cly9pnbfRxT6/31c3dRWxIiwGnMSWwZjHKOuY3EVmijs7k1jz/9bLA==" crossorigin="anonymous"></script>
	<style>
		.hidden {
			display:none!important;
		}
		.alert {
			position:fixed;
			z-index:3;
			left:20%;
			right:20%;
			width:auto;
			margin:10px 10px;
		}
		.spacer {
			margin-top:10px;
		}
	</style>
	<script crossorigin="anonymous">
		axios.defaults.headers.common['X-Requested-With'] = 'XMLHttpRequest';
		axios.default.withCredentials = true;

		const statusStr = (str)=>{
			switch(str){
				case 'WISH':
					return "Waiting for peer";
				default:
					return "Unknown";
			}
		}

        const vm = new Vue({
           	el: '#main',
           	data: {
           		baseUrl: location.protocol+'//'+location.hostname+(location.port ? ':'+location.port: ''),
           		hideGit:true,
           		modeHome: true,
           		error: undefined,
           		user: undefined,
           		status: undefined,
           		stats: undefined,
           		exchangeTarget: -1,
            },
            methods: {
				updateUser: function(){
					return axios.get(this.baseUrl+'/me')
					.then(reply=>reply.data)
					.then(data=>{
						if(data && data.name && data.email && data.sciper && data.group){
							this.user = data;
						}else{
							this.user = undefined;
						}
					})
                    .catch(err => {
                    	if(err.response) this.error = err.response.data.status;
                    });
				},
				updateStatus: function(){
					return axios.get(this.baseUrl+'/status')
					.then(reply=>reply.data)
					.then(data=> {
						this.status = data;
						this.error = null;
						if(data.status == "DONE")
							this.user.group = data.target;
					})
                    .catch(err => {
                    	if(err.response) this.error = err.response.data.status;
                    });
				},   
				updateStats: function(){
					return axios.get(this.baseUrl+'/stats')
					.then(reply=>reply.data)
					.then(data=> {
						this.stats = data;
						this.error = null;
					})
                    .catch(err => {
                    	if(err.response) this.error = err.response.data.status;
                    });
				},
				requestExchange: function(){
					return axios.get(this.baseUrl+'/echange', {params:{target:document.getElementById('target').value}})
					.then(reply=>reply.data)
					.then(data=> {
						this.status = data;
						this.error = null;
					})
                    .catch(err => {
                    	if(err.response) this.error = err.response.data.status;
                    });
				},
            },
            mounted: function(event){
			    this.updateUser().then(r=>{
			    	if(this.user != undefined){
				    	this.updateStatus();
				    	if(this.user.isAdmin){
					    	this.updateStats();
				    	}
					}
			    })
			    
			},
        });
    </script>
</html>